
KolourPaint 4 Series (trunk/KDE/)
====================

KolourPaint 4.0.0 BETA (Frozen 2007-10-26)

   * Port to KDE 4 (Clarence Dang, Laurent Montel)

     Note: This is a beta release and has not been through a full QA review.
           If you want stability, use KolourPaint/KDE3, which can be
           installed in parallel with KolourPaint4 BETA and runs under KDE4.

   * Configurable Color Palette

   * Add "Hue, Saturation, Value" effect (Mike Gashler)

   * Add "Histogram Equalizer" effect (Mike Gashler)

   * Add Zoom Tool

   * Add "File / Properties..."

   * Rectangles, rounded rectangles and ellipsed are now bounded by
     the dimensions of the dragged out rectangle

   * Add, to the print dialog, a choice between printing the image at the
     top-left of the page or at the center (this was previously a hidden
     configuration option)
     (Bug #33481)

   * Add hidden configuration option "Open Images in the Same Window"
     (Bug #125116)

   * Add "Rotate Left" (CTRL+SHIFT+Left) and "Rotate Right" (CTRL+SHIFT+R)
     to "Image" menu as a quick way to access the common types of "Rotate..."
     (Bug #135184, #141530))

   * Add "Fit to Page", "Fit to Page Width" and "Fit to Page Height" to the
     "View" Menu

   * Add "Image / Draw Opaque" menu item since some users expect it.
     It duplicates the functionality of the already existent Tool Box widget.

   * Animate the Color Similarity Tool Bar Item, to highlight the existence
     of the feature
     - And make the configuration more accessible
       - Also add "Image / Draw With Color Similarity" to duplicate the tool
         bar item

   * Make the Tool Box use as much vertical space as possible, since it
     needs it for the option widgets.

   * Save local files atomically - KolourPaint will no longer truncate
     an existing file if the KImageIO plugin for the file format is
     missing or if you run out of disk space.
     [also in branches/KDE/3.5]

   * Add "File / Scan..." feature (Martin Koller)
     [also in branches/KDE/3.5/]

   * Fix crash triggered by rapidly deselecting a selection after
     drag-scaling the selection (Bug #117866)
     [also in branches/KDE/3.[345]/, branches/kolourpaint/1.2_kde3/]

   * Add global session save/restore (Bug #94651)
     [also in branches/KDE/3.5/]

   * Make "File / Open Recent" consistently work when multiple windows are
     open
     [also in branches/KDE/3.5/]

   * CTRL+C'ing a text box also places the text in the middle-mouse-button
     clipboard, in lieu of being able to highlight the text to do this
     [also in branches/KDE/3.5/]

   * Change minimum allowed zoom level for the grid from 600% to 400%
     [also in branches/KDE/3.5/]

   * Printing improvements (Bug #108976)
     - Respect image DPI
     - Fit image to page if image is too big
     - Center image on page
     [also in branches/KDE/3.5/]

   * Paste transparent pixels as black instead of uninitialized colors,
     when the app does not support pasting transparent pixels (such as
     OpenOffice.org)
     [also in branches/KDE/3.5/]

   * Make "Edit / Paste in New Window" always paste white pixels as white
     (it used to paste them as transparent when the selection transparency
      mode was set to Transparent)
     [also in branches/KDE/3.5/]

   * REGRESSION: The "Skew", "Rotate" and "Smooth Scale" effects produce
                 low quality results
                 (Bug #30)

   * REGRESSION: The rendering quality of a text box with opaque text but
                 a see-through background, on top of transparent document
                 areas, is lower than in KDE 3 versions of KolourPaint
                 (Bug #31)

   * REGRESSION: Spinboxes do not support text input
                 (see the "Update" part of Bug #4)

   * REGRESSION: InputMethod support was not ported to Qt4 so has been disabled
                 (Bug #27)

   * REGRESSION: The Tool Box and Color Tool Bar are no longer movable or
                 floatable
                 (Bug #29)

    KolourPaint 4.0.0 BETA contains all the fixes and features in KolourPaint
    1.4.8_relight (KDE 3.5.8), even though not all of them were listed
    above.


KolourPaint 1.4_relight Series (branches/KDE/3.5/)
===============================

KolourPaint 1.4.1_relight (Frozen 2006-01-15)

   * Updated documentation (Thurston)

KolourPaint 1.4_relight (Frozen 2005-11-08)

   * New icons (Danny Allen, Nuno Pinheiro)

   * Tool Box icon size is 22x22, not 16x16, at screen resolution >= 1024x768

   * CTRL + Mouse Wheel = Zoom

   * While freehand selection scaling, holding Shift maintains aspect ratio

   * Prevent accidental drags in the Colour Palette from pasting text
     containing the colour code
     [also in branches/KDE/3.[34]/, branches/kolourpaint/1.2_kde3/]

   * Cells in the bottom row and cells in the rightmost column of the Colour
     Palette are now the same size as the other cells
     [also in branches/KDE/3.[34]/, branches/kolourpaint/1.2_kde3/]

   * Text drops to the empty part of the scrollview will not be placed
     outside the document
     [also in branches/KDE/3.[34]/, branches/kolourpaint/1.2_kde3/]

   * Rename icons from "hi" to "cr" - back to the state of 1.0 (Danny Allen)
     but leave application icons as "hi" (Jonathan Riddell)

   * Enforce text box font height to prevent e.g. Chinese characters in
     buggy fonts from enlarging the text box and putting the cursor out of
     sync with the text
     [also in branches/KDE/3.[34]/, branches/kolourpaint/1.2_kde3/]

   * Clicking in a text box selects a character based on its midpoint -
     not leftmost point - to be consistent with all text editors
     (esp. noticeable with big fonts)
     [also in branches/KDE/3.[34]/, branches/kolourpaint/1.2_kde3/]

   * Return and Numpad 5 Key now draw
     [also in branches/KDE/3.[34]/, branches/kolourpaint/1.2_kde3/]

   * Tool Actions placed outside the Tool Box resize with their toolbars
     [also in branches/KDE/3.[34]/, branches/kolourpaint/1.2_kde3/]

   * Ensure Color Similarity maximum is 30, not 29 due to gcc4
     [also in branches/KDE/3.[34]/, branches/kolourpaint/1.2_kde3/]

   * Tool Box traps right clicks (for the RMB Menu) on top of tool options
     widgets and the empty part of the Tool Box
     [also in branches/KDE/3.[34]/, branches/kolourpaint/1.2_kde3/]

   * Correct and update image format associations to all formats supported
     by KDE 3.5 (kdelibs/kimgio/:r466654)

   * String fixes (Stefan Winter)
     [also in branches/KDE/3.4/]

   * Other string fixes (Malcolm Hunter, Clarence Dang, Stephan Binner)


KolourPaint 1.4_light Series (branches/KDE/3.4/)
============================

KolourPaint 1.4_light (Frozen 2005-02-22)
   * Antialias text when the text box has a transparent background (Bug #24)
     [later backported to branches/KDE/3.3/, branches/kolourpaint/1.2_kde3/]
   * Add Unzoomed Thumbnail Mode and Thumbnail Rectangle
   * Add RMB context menu for when a selection tool is active (closing KDE
     Bug #92882)
   * More intuitive "Set as Image" behaviour (esp. with selection borders).
     Thanks to Michael Lake for the feedback.
     [later backported to branches/KDE/3.3/, branches/kolourpaint/1.2_kde3/]
   * InputMethod support
     [later backported to branches/kolourpaint/1.2_kde3/]
   * Save "More Effects" dialog's last effect to config file
   * Save "Resize / Scale" dialog's last "Keep aspect ratio" setting to
     config file
   * Add "Help / Acquiring Screenshots"
   * Fix selection regressions introduced in 1.2:
     - Make selection dragging with CTRL work again (copies selection onto
       document)
     - When creating freeform selections, include the starting point; also
       avoids a QRegion crash with constructing 1-point regions
     [also in branches/KDE/3.3/, branches/kolourpaint/1.2_kde3/]
   * Fix other selection bugs:
     - When the user drags very quickly on a resize handle, resize the
       selection instead of moving it
     - Draw resize handles above the grid lines - not below - so that the
       handles are always visible if they are supposed to be there
     [also in branches/KDE/3.3/, branches/kolourpaint/1.2_kde3/]
   * Smaller selection and text box resize handles (visually not
     actually) - covers up fewer selected pixels, doesn't cover up text
     [also in branches/KDE/3.3/, branches/kolourpaint/1.2_kde3/]
   * Restore mouse cursor after deselecting selection/text tools
     [also in branches/KDE/3.3/, branches/kolourpaint/1.2_kde3/]
   * Empty text clipboard fixes:
     - Don't get stuck on a wait cursor after attempting to paste empty
       text into a text box
     - Prevent pasting text from creating a new text box if text is empty
     - Prevent copying of empty text box
     [also in branches/KDE/3.3/, branches/kolourpaint/1.2_kde3/]
   * Speed up renderer (most noticeable with diagonal drag-scrolling at
     high zoom)
     - Don't paint anything outside of the view's visible region
       (previously, clipped only on view _widget_ region)
     - Region-aware: paint component rectangles of the update region,
       rather than the bounding rectangle
     [also in branches/KDE/3.3/, branches/kolourpaint/1.2_kde3/]
   * When changing between colour depth and quality widgets in the save
     filedialog, make sure "Convert to:" and "Quality:" are correctly
     rendered (hacking around a Qt redraw glitch)
     [also in branches/KDE/3.3/, branches/kolourpaint/1.2_kde3/]
   * Fix crash after using the Colour Picker if it was the first used tool
     [kolourpaint-1.2.2_kde3-color_picker_crash.diff]
     [also in branches/KDE/3.3/, branches/kolourpaint/1.2_kde3/]
   * Fix crash due to text box when scaling image behind it
     [also in branches/KDE/3.3/, branches/kolourpaint/1.2_kde3/]
   * Even when the thumbnail has focus (and not the main window), blink the
     text cursor in all views
     [kolourpaint-1.2.2_kde3-thumbnail_blink_text_cursor.diff]
     [also in branches/KDE/3.3/, branches/kolourpaint/1.2_kde3/]
   * Correct "Soften" and "Sharpen" commands' command history names
   * Correct invert commands' command history names
   * Fix remaining untranslatable strings (closing KDE Bug #85785)
     [also in branches/KDE/3.3/, branches/kolourpaint/1.2_kde3/]
   * Update image format associations to all formats supported by KDE 3.4
   * Remove unused images in doc directory
     [also in branches/KDE/3.3/, branches/kolourpaint/1.2_kde3/]
   * Correct kolourpaint.desktop "Terminal=" and "Categories=" syntax
     (Benjamin Meyer)


KolourPaint 1.2 Series (branches/KDE/3.3/)
======================

Version 1.2 "ByFiat Everytime" (2004-08-18)
   * Add up to 500 levels of Undo/Redo (minimum of 10 levels, maximum of
     500 as long as the total history size < 16MB)
   * Add freehand resizing of image
   * Add freehand smooth scaling of selections
   * [also in 1.0 branch] New icons (Kristof Borrey)
   * [also in 1.0 branch] Prefer Crystal SVG text icons over KolourPaint's
   * [also in 1.0 branch] Add documentation in the KDE Help Centre
   * Add drag scrolling
   * Add "More Effects" dialog:
     - Balance (Brightness, Contrast, Gamma)
     - Emboss
     - Flatten
     - Invert (with choice of channels)
     - Reduce Colours
     - Soften & Sharpen
   * File saving improvements:
     - Support colour depths (optional dithering) and "colour monochrome"
     - Support JPEG quality
     - Realtime file dialog preview with estimated file size
     - Retain PNG metadata
     - Prompt when attempting lossy save
     - Correctly save transparent selections (not as opaque)
   * Dither more often when loading (and pasting) images for better quality
   * Single key shortcuts for all tools and tool options (automatically
     turned off when editing text but can then use Alt+Shift+<key>)
   * Arrow keys now move one document pixel - not view pixel - at a time
     (more usable when zoomed in)
   * Fix selection bugs:
     - Fix duplicate "Selection: Create" undo entries (Bug #5a)
     - Allow redoing of selection operation if border deselected (Bug #5b)
     - Don't print to STDERR when undoing a selection border create
       operation and border has already been deselected
     - [also in 1.0 branch] When pulling a selection from the document,
       only set the bits of the document to the background colour where the
       transparent selection is opaque in the same place (this is only
       noticeable with colour similarity turned on).  Now moving a
       selection away and then back to its original place is always a NOP
       as it should be.
   * Selections can be deselected using Esc or clicking on icon in Tool Box
   * Accidental drag detection when deselecting selections or text boxes
   * Prevent selection from being moved completely offscreen (at least 1
     pixel of the selection will stay within the view)
   * Speed up copying selection when transparency is on
   * Improve Text Tool usability:
     - Allow single click creation of text box with a sane default size
     - Allow freehand resizing of text boxes
     - Add Opaque/Transparent selector for greater usability and
       consistency with selections
     - Minimum size is now 7x7 document pixels (1x1 - not 4x4 - border)
     - Text cursor doesn't overlap border anymore
     - When dropping text, paste at drop point
     - When MMB pasting creates a new text box, do so at mouse position
   * When MMB pasting text in an existing box, correctly paste multiline
     clipboard contents
   * Improve text quality:
     - With a transparent background, don't antialias foreground opaque
       text with arbitrarily chosen black
     - Make sure transparent text shows up on opaque (usually, grey was
       problematic) background
   * Improve Resize/Scale dialog usability:
     - Add Smooth Scale (useful for creating screenshot thumbnails)
     - Allow manipulating image when selection is active
     - Operation choices stand out as massive, easily clickable buttons
     - Default focus on operation choices
   * Warn if Resize/Scale, Rotate or Skew will take lots of memory
   * Limit startup image size to 2048x2048
   * Eliminate flicker when scrolling
   * Thumbnail fixes:
     - Reduce flicker when appearing (Bug #2)
     - More reasonable minimum size (actually enforce it)
     - [also in 1.0 branch] Use deleteLater()
     - [also in 1.0 branch] Save geometry even if it's closed very quickly
       after a geometry change
   * Restore last used tool and tool options on startup
   * Add Export, Copy To File, Paste From File, Paste in New Window,
     Full Screen Mode
   * Add Zoom In/Out buttons to main toolbar
   * Rename Crop options in an attempt to reduce confusion:
     - "Autocrop" --> "Remove Internal Border" when selection active
     - "Crop Outside Selection" --> "Set as Image (Crop)"
   * "Set as Image" changes:
     - Enable for text boxes
     - Underneath transparent bits of selection, fill image with
       transparent rather than with background colour
   * Permit "reloading" of an empty document
   * Fixes when the current URL doesn't exist:
     - Don't reload if underlying file disappeared
     - Don't add non-existent file to Recent Files history
     - Ask to save before mailing or setting as wallpaper
   * Only enable Show Path when there is a URL
   * Pop up dialog (instead of printing to STDERR) and disable Edit/Paste
     on CTRL+V if the clipboard contents disappeared due to the source
     application quitting (and Klipper didn't retain clipboard contents)
   * Image/Clear now always sets _everything_ within the selection boundary
     to the background colour - including transparent pixels
   * Add Preview button to Colour Similarity Dialog to work around Bug #4
     regarding spinboxes and enter key
   * Colour Picker disallows trying to pick colour outside of image
   * Make sure colour palette contains valid and visible colours at 8-bit
   * [also in 1.0 branch] Fix (big) memory leak on kpSelection destruction
     (Albert Astals Cid)
   * Don't leak image dialogs' memory
   * [also in 1.0 branch] Don't let C++ destruct the mask bitmap before its
     painter when dbl-clicking the color eraser does NOP (avoids
     QPaintDevice and X error)
   * [also in 1.0 branch] Check for QImageDrag::canDecode() before calling
     QImageDrag::decode() (prevents X and valgrind errors)
   * [also in 1.0 branch] Fix compilation problem with QT_NO_ASCII_CAST
     (Waldo Bastian)
   * [also in 1.0 branch] Decrease application preference to below that of
     a viewer (Stephan Kulow)
   * Remember dialog dimensions
   * Remove double dialog margins
   * Fix missing i18n()'s
   * Fix some untranslatable strings
   * [also in 1.0 branch] Corrected several strings
   * Remove unused icons


KolourPaint 1.0 Series (branches/kolourpaint/1.0/)
======================

Version 1.0 "Seagull" (2004-02-29)
   * First stable release

